<?php

namespace Drupal\layout_builder_enhancements_layout\Plugin\LayoutFeature;

use Drupal\Core\Form\FormStateInterface;
use Drupal\layout_builder_enhancements_layout\Plugin\LayoutFeaturePluginBase;

/**
 * Add classes to section plugin.
 *
 * @LayoutFeaturePlugin(
 *   id = "classes",
 *   label = "Classes",
 * )
 */
class Classes extends LayoutFeaturePluginBase
{

  /**
   * {@inheritDoc}
   */
  public function defaultConfiguration() {
    return [
      'class' => ''
    ];
  }

  /**
   * {@inheritDoc}
   */
  public function buildConfigurationForm(array $form, FormStateInterface $form_state)
  {
    $options = [];
    $configuration = $this->getConfiguration();

    foreach ($configuration['classes'] as $key => $title) {
      $options[$key] = $title;
    }
    $form['class'] = [
      '#type' => 'select',
      '#title' => 'Add a section class',
      '#options' => $options,
      '#default_value' => $configuration['class'],
    ];
    return $form;
  }

  /**
   * {@inheritDoc}
   */
  public function validateConfigurationForm(array &$form, FormStateInterface $form_state) {
  }

  /**
   * {@inheritDoc}
   */
  public function submitConfigurationForm(array &$form, FormStateInterface $form_state) {
    $this->configuration['class'] = $form_state->getValue('class');
  }

  /**
   * {@inheritDoc}
   */
  public function build(array &$build, array $regions) {
    $configuration = $this->getConfiguration();
    if (empty($configuration['class'])) {
      return;
    }
    $build['#attributes']['class'][] = $configuration['class'];
  }

}
